package net.javase.hksup.starter.config;

import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import net.javase.hksup.starter.service.AlarmServer;
import net.javase.hksup.starter.service.CmsServer;
import net.javase.hksup.starter.service.SsServer;
import org.springframework.boot.context.properties.EnableConfigurationProperties;
import org.springframework.context.ApplicationContext;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

/**
 * HkSupSdkConfiguration
 *
 * @author Frank
 */
@Slf4j
@Configuration
@RequiredArgsConstructor
@EnableConfigurationProperties(HkSupSdkProperties.class)
public class HkSupSdkConfiguration {

    private final HkSupSdkProperties hkSupSdkProperties;

    private final ApplicationContext applicationContext;

    @Bean(initMethod = "startServer", destroyMethod = "stopServer")
    public AlarmServer alarmServer() {
        return new AlarmServer(applicationContext, hkSupSdkProperties);
    }


    @Bean(initMethod = "startCmsServer", destroyMethod = "stopCmsServer")
    public CmsServer cmsServer() {
        return new CmsServer(hkSupSdkProperties, applicationContext);
    }


    @Bean(initMethod = "startSsServer", destroyMethod = "stopSsServer")
    public SsServer ssServer() {
        return new SsServer(hkSupSdkProperties, applicationContext);
    }
}
