package net.javase.hksup.starter.config;

import lombok.Getter;
import lombok.Setter;
import net.javase.hksup.starter.utils.SystemUtil;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.util.StringUtils;

import java.io.File;

/**
 * HkSupSdkProperties
 *
 * @author Frank
 */
@Getter
@Setter
@ConfigurationProperties("hk.sup")
public class HkSupSdkProperties {

    private String cmsServerIp;

    private Integer cmsServerPort = 7660;

    private String dasServerIp;

    private Integer dasServerPort = 7660;

    private String smsServerIp;

    private Integer smsServerPort = 7665;

    private String smsServerListenIp = "127.0.0.1";

    private Integer smsServerListenPort = 7665;

    private String smsBackServerIp;

    private Integer smsBackServerPort = 8000;

    private String smsBackServerListenIp = "127.0.0.1";

    private Integer smsBackServerListenPort = 8000;

    private String voiceSmsServerIp;

    private Integer voiceSmsServerPort = 7500;

    private String voiceSmsServerListenIp = "127.0.0.1";

    private Integer voiceSmsServerListenPort = 7500;

    private String alarmServerIp;

    private Integer alarmServerTCPPort = 7663;

    private Integer alarmServerUDPPort = 7662;

    private Integer alarmServerType;

    private String alarmServerListenIp = "127.0.0.1";

    private Integer alarmServerListenTcpPort = 7663;

    private Integer alarmServerListenUdpPort = 7662;

    private String picServerIp;

    private Integer picServerPort = 6011;

    private Integer picServerType;

    private String picServerListenIp = "127.0.0.1";

    private Integer picServerListenPort = 6011;

    private String kmsUsername = "test";

    private String kmsPassword = "12345";

    private String szAk = "test";

    private String szSk = "12345";

    /**
     * ISUP5.0登录秘钥
     */
    private String key;

    /**
     * lib目录
     */
    private String libPath;

    private Boolean jnaDebug = false;

    private String sdkLogPath;


    /**
     * lib根目录
     */
    public String libPath() {
        String libPath = getLibPath();
        if (!StringUtils.hasText(libPath)) {
            return SystemUtil.userDir() + File.separator + "lib" + File.separator;
        }
        return libPath.endsWith(File.separator) ? libPath : libPath + File.separator;
    }

    /**
     * 日志根目录
     */
    public String logPath() {
        String logPath = getSdkLogPath();
        return StringUtils.hasText(logPath) ? logPath : SystemUtil.userDir() + File.separator + "EHomeSDKLog";
    }

}
