package net.javase.hksup.starter.model;

import com.alibaba.fastjson2.annotation.JSONField;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import java.io.Serializable;

/**
 * FaceInfoParam
 *
 * @author Frank
 */
@Getter
@Setter
@NoArgsConstructor
@AllArgsConstructor
public class FaceInfoParam implements Serializable {

    /**
     * 人脸图片URL，ISUP协议下发人脸使用URL方式
     */
    private String faceURL;

    /**
     * 人脸库类型 <br>
     * [blackFD#名单库,staticFD#静态库]
     */
    private String faceLibType = "blackFD";

    /**
     * 人脸库ID, 最大长度为63字节,多个人脸库用逗号隔开
     */
    @JSONField(name = "FDID")
    private String FDID = "1";

    /**
     * 人员工号，以人为中心方式，下发人脸前需要先下发人员工号，人脸绑定在工号上
     */
    @JSONField(name = "FPID")
    private String FPID;

    public FaceInfoParam(String faceURL, String FPID) {
        this.faceURL = faceURL;
        this.FPID = FPID;
    }
}
