package net.javase.hksup.starter.model;

import com.alibaba.fastjson2.annotation.JSONField;
import lombok.Getter;
import lombok.Setter;

import java.io.Serializable;

/**
 * SearchFaceInfoParam
 *
 * @author Frank
 */
@Getter
@Setter
public class SearchFaceInfoParam implements Serializable {

    /**
     * 搜索起始位置 默认从0开始
     */
    private Integer searchResultPosition = 0;

    /**
     * 本次查询条数, 单次搜索范围为1-500条, 设备默认返回1-500条
     */
    private Integer maxResults = 30;

    /**
     * 人脸库类型 <br>
     * [blackFD#名单库,staticFD#静态库]
     */
    private String faceLibType = "blackFD";

    /**
     * 人脸库ID, 最大长度为63字节,多个人脸库用逗号隔开
     */
    @JSONField(name = "FDID")
    private String FDID = "1";

    /**
     * 人员工号，以人为中心方式，下发人脸前需要先下发人员工号，人脸绑定在工号上
     */
    @JSONField(name = "FPID")
    private String FPID;

    public SearchFaceInfoParam() {
    }

    public SearchFaceInfoParam(String FPID) {
        this.FPID = FPID;
    }

    public SearchFaceInfoParam(Integer searchResultPosition, Integer maxResults, String faceLibType, String FDID, String FPID) {
        this.searchResultPosition = searchResultPosition;
        this.maxResults = maxResults;
        this.faceLibType = faceLibType;
        this.FDID = FDID;
        this.FPID = FPID;
    }
}
